// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from mola_msgs:srv/MapLoad.idl
// generated code does not contain a copyright notice

#ifndef MOLA_MSGS__SRV__DETAIL__MAP_LOAD__FUNCTIONS_H_
#define MOLA_MSGS__SRV__DETAIL__MAP_LOAD__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "mola_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "mola_msgs/srv/detail/map_load__struct.h"

/// Initialize srv/MapLoad message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mola_msgs__srv__MapLoad_Request
 * )) before or use
 * mola_msgs__srv__MapLoad_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__init(mola_msgs__srv__MapLoad_Request * msg);

/// Finalize srv/MapLoad message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Request__fini(mola_msgs__srv__MapLoad_Request * msg);

/// Create srv/MapLoad message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mola_msgs__srv__MapLoad_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
mola_msgs__srv__MapLoad_Request *
mola_msgs__srv__MapLoad_Request__create();

/// Destroy srv/MapLoad message.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Request__destroy(mola_msgs__srv__MapLoad_Request * msg);

/// Check for srv/MapLoad message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__are_equal(const mola_msgs__srv__MapLoad_Request * lhs, const mola_msgs__srv__MapLoad_Request * rhs);

/// Copy a srv/MapLoad message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__copy(
  const mola_msgs__srv__MapLoad_Request * input,
  mola_msgs__srv__MapLoad_Request * output);

/// Initialize array of srv/MapLoad messages.
/**
 * It allocates the memory for the number of elements and calls
 * mola_msgs__srv__MapLoad_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__Sequence__init(mola_msgs__srv__MapLoad_Request__Sequence * array, size_t size);

/// Finalize array of srv/MapLoad messages.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Request__Sequence__fini(mola_msgs__srv__MapLoad_Request__Sequence * array);

/// Create array of srv/MapLoad messages.
/**
 * It allocates the memory for the array and calls
 * mola_msgs__srv__MapLoad_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
mola_msgs__srv__MapLoad_Request__Sequence *
mola_msgs__srv__MapLoad_Request__Sequence__create(size_t size);

/// Destroy array of srv/MapLoad messages.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Request__Sequence__destroy(mola_msgs__srv__MapLoad_Request__Sequence * array);

/// Check for srv/MapLoad message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__Sequence__are_equal(const mola_msgs__srv__MapLoad_Request__Sequence * lhs, const mola_msgs__srv__MapLoad_Request__Sequence * rhs);

/// Copy an array of srv/MapLoad messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Request__Sequence__copy(
  const mola_msgs__srv__MapLoad_Request__Sequence * input,
  mola_msgs__srv__MapLoad_Request__Sequence * output);

/// Initialize srv/MapLoad message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * mola_msgs__srv__MapLoad_Response
 * )) before or use
 * mola_msgs__srv__MapLoad_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__init(mola_msgs__srv__MapLoad_Response * msg);

/// Finalize srv/MapLoad message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Response__fini(mola_msgs__srv__MapLoad_Response * msg);

/// Create srv/MapLoad message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * mola_msgs__srv__MapLoad_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
mola_msgs__srv__MapLoad_Response *
mola_msgs__srv__MapLoad_Response__create();

/// Destroy srv/MapLoad message.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Response__destroy(mola_msgs__srv__MapLoad_Response * msg);

/// Check for srv/MapLoad message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__are_equal(const mola_msgs__srv__MapLoad_Response * lhs, const mola_msgs__srv__MapLoad_Response * rhs);

/// Copy a srv/MapLoad message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__copy(
  const mola_msgs__srv__MapLoad_Response * input,
  mola_msgs__srv__MapLoad_Response * output);

/// Initialize array of srv/MapLoad messages.
/**
 * It allocates the memory for the number of elements and calls
 * mola_msgs__srv__MapLoad_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__Sequence__init(mola_msgs__srv__MapLoad_Response__Sequence * array, size_t size);

/// Finalize array of srv/MapLoad messages.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Response__Sequence__fini(mola_msgs__srv__MapLoad_Response__Sequence * array);

/// Create array of srv/MapLoad messages.
/**
 * It allocates the memory for the array and calls
 * mola_msgs__srv__MapLoad_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
mola_msgs__srv__MapLoad_Response__Sequence *
mola_msgs__srv__MapLoad_Response__Sequence__create(size_t size);

/// Destroy array of srv/MapLoad messages.
/**
 * It calls
 * mola_msgs__srv__MapLoad_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
void
mola_msgs__srv__MapLoad_Response__Sequence__destroy(mola_msgs__srv__MapLoad_Response__Sequence * array);

/// Check for srv/MapLoad message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__Sequence__are_equal(const mola_msgs__srv__MapLoad_Response__Sequence * lhs, const mola_msgs__srv__MapLoad_Response__Sequence * rhs);

/// Copy an array of srv/MapLoad messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_mola_msgs
bool
mola_msgs__srv__MapLoad_Response__Sequence__copy(
  const mola_msgs__srv__MapLoad_Response__Sequence * input,
  mola_msgs__srv__MapLoad_Response__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // MOLA_MSGS__SRV__DETAIL__MAP_LOAD__FUNCTIONS_H_
